zoukankan      html  css  js  c++  java
  • HDU_1969_二分

    Pie

    Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 9814    Accepted Submission(s): 3568


    Problem Description
    My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

    My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

    What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.
     
    Input
    One line with a positive integer: the number of test cases. Then for each test case:
    ---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
    ---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.
     
    Output
    For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).
     
    Sample Input
    3 3 3 4 3 3 1 24 5 10 5 1 4 2 3 4 5 6 5 4 2
     
    Sample Output
    25.1327 3.1416 50.2655
     

    题意:给出n个蛋糕的半径,还有m+1个人,每个人的馅饼必须是整块的,不能拼接,求最大的。

    思路:因为不能拼接,所以直接在最大那块的面积与0之间二分求即可

    #include<iostream>
    #include<cstring>
    #include<cstdio>
    #include<queue>
    #include<cmath>
    #include<algorithm>
    using namespace std;
    
    #define PI acos(-1.0)
    int n,f;
    double area[10005];
    bool ok(double a)
    {
        int num=0;
        for(int i=0;i<n;i++)
            num+=(int)(area[i]/a);
        if(num>=f+1)
            return 1;
        else
            return 0;
    }
    
    int main()
    {
        int r,t;
        scanf("%d",&t);
        while(t--)
        {
            scanf("%d%d",&n,&f);
            double maxn=0;
            for(int i=0;i<n;i++)
            {
                scanf("%d",&r);
                area[i]=r*r*PI;
                if(area[i]>maxn)
                    maxn=area[i];
            }
            double L=0,R=maxn;
            while(R-L>1e-5)
            {
                double M=(R+L)/2;
                if(ok(M))
                    L=M;
                else
                    R=M;
            }
            printf("%.4lf
    ",L);
        }
        return 0;
    }
  • 相关阅读:
    [洛谷P2711]小行星
    [洛谷P2264]情书
    [洛谷P2626]斐波那契数列(升级版)
    [洛谷P3195][HNOI2008]玩具装箱TOY
    [洛谷P3254]圆桌问题
    [洛谷P1251]餐巾计划问题
    [洛谷P4015]运输问题
    [洛谷P2604][ZJOI2010]网络扩容
    [洛谷P4001][BJOI2006]狼抓兔子
    [洛谷P3153] [CQOI2009]跳舞
  • 原文地址:https://www.cnblogs.com/jasonlixuetao/p/5823487.html
Copyright © 2011-2022 走看看